#include "exp004init.h"
#include "exp004state0.h"
#include "../model/geometry/density_legend_geometry.h"
#include "../model/geometry/map_geometry.h"
#include "../model/geometry/protein_geometry.h"
#include "../model/geometry/protein_selected_geometry.h"
#include "../model/selection_info_init.h"
#include "../model/zoom_info_init.h"
#include "../model/exp004base.h"
#include <GL/glut.h>

#define S exp004state0

void
exp004init (void)
{
  /*
   * Initialize default values, zero memory and NULL pointers.
   */
  S.rows = 0;
  S.gi_data = NULL;
  S.base_vertices_data = NULL;
  S.base_colors_data = NULL;
  selection_info_init (&S.selection);
  zoom_info_init (&S.zoom);
  S.legend = true;

  /*
   * Load the data.
   */
  exp004base ();

  /*
   * Create the geometry based on the data.
   */
  S.list_offset = glGenLists (NUM_LISTS);
  protein_geometry ();
  protein_selected_geometry ();
  density_legend_geometry ();
  map_geometry ();

  return;
}
